'Egy BASIC mintaprogram a PICPLC1 panelre.
'stip/dir lptet motor meghajt panel vezrlse

'Config - fuse bit - bellts
'A proci beptett rajelgenertort hasznlom - INTOSC - s kdvdelem - CP - kikapcsolva
'A PLL rajel ngyszerez, s az alacsonyfeszltsg programozs - LVP - kikapcsolva. 
#CONFIG             
    __config _CONFIG1, _FOSC_INTOSC & _CP_OFF
    __config _CONFIG2, _PLLEN_ON & _LVP_OFF 
#endCONFIG

'    OSCCON = %01101010   ' Belltom 4 megra a bels rajelet
'    OSCCON = %01111010   ' Belltom 16 megra a bels rajelet
    OSCCON = %11110000   ' Belltom 32 megra a bels rajelet    
    
    DEFINE OSC 32
    
' Akr 14 lb hasznlhat analg bemenetnek, de most minden lbat digitlis portnak akarunk.

   ANSELA = %00000000    ' porta mind digitlis
   ANSELB = %00000000    ' portb mind digitlis
   ANSELD = %00000000    ' portd mind digitlis
   ANSELE = %00000000    ' porte mind digitlis
    
	ADCON1 = %00000110	' Az ADCON1 regiszter 

     
    ' A timer2 bemenetn az rajel negyede van. (fosc/4)
    ' Ezt osztom elbb 1-el, majd 4-el, s bekapcsolom a Timer2-t: 
   ' T2CON = %00000100  ' belltjuk 1-re az elosztt, 1-re msodik osztt, s bekapcsoljuk a TMR2-t.
    ' Van egy PR2 nev regiszter, aminek a tartalmt a proci folyamatosan sszehasonltja a TIMER2 tartalmval
    ' Ha elri, akkor a TIMER2 tartalmt nullzza, s a Timer2 interrupt 
    ' flag bitet, a PIR1.1 -et 1-be rakja.
       
   
  '  PR2 = 3           ' 0 to 9 = 10. 10*4*1*1uS=0.25mS

    
 ' OPTION_REG 7. = 0 bels felhzk engedlyezve, 6. = 1 felfut l, 5.=0 forrs fosc/4, 4. = 0, 3.= 1 eloszt kikapcsolva, 2.-1.-0. elszt  
   '              76543210   		
    OPTION_REG = %01011000			
' INTCON: 7.ltalnos megszakts engedlyezs, 6.perifria megszakts tiltva, 5.=1 timer0 tlcsorduls megszakts engedlyezve   
'             76543210
    INTCON = %10100000 			
	'INTCON = $a0 		' Enable TMR0 interrupts
   ' T1CON 6,7 = 00 fosc/4, 4,5 eloszt 1:4 = 10, 3. = 0 LP osci tiltva,2.= 1 , 1.=0 nem hasznlt, 0.=1 timer1 engedlyezve  
   '        76543210
   ' T1CON =%00100101	
    
   ' PIE1.0 = 1   'Enables the Timer1 overflow interrupt
      On Interrupt Goto tickint
       
'Elszr is kzljk a programmal, hol tallja az LCD-t, es hogyan akarjuk vezrelni:
 
	DEFINE LCD_DREG 	PORTD ' Az LCD adatvezetket a D portrol vezreljk
	DEFINE LCD_DBIT 	0	' Az els adatvezetk az RD port 0. tagja. (Az RD0)
	DEFINE LCD_RSREG 	PORTD ' Az LCD Register Select kivezetse a D portra csatlakozik,
	DEFINE LCD_RSBIT 	4	' mgpedig az RD4 labra. (Tehat az LCD RS - az RD4 porton van.)
	DEFINE LCD_EREG 	PORTD ' Az enable vezerl bit is a D porton,
	DEFINE LCD_EBIT 	5	' az RD5 portra van kiosztva. (LCD EN - RD5 port.)
	DEFINE LCD_BITS 	4	' a 4 bites uzemmodot vlasztjuk,
	DEFINE LCD_LINES 	2	' es 2 soros az LCD

	TRISA = %00001000	' A PORTA0-1-2-4-5-6-7 output  , PORTA.3 input
	TRISB = %00000000	' A PORTB0-7 output
	TRISC = %00111100	' A PORTC 2-5 input, a PORTC 0-1 s 6-7 output

	CLOCK VAR PORTA.0
	DIR VAR PORTA.1
    EN VAR PORTA.2
  	BEMENET VAR PORTA.3    
    
	K1GOMB var PORTC.2			' A K1 nyomgomb a PORTC 2-n van,
	K2GOMB var PORTC.3			' A K1 nyomgomb a PORTC 3-n van,
	K3GOMB var PORTC.4			' A K1 nyomgomb a PORTC 4-n van,
	K4GOMB var PORTC.5			' A K1 nyomgomb a PORTC 5-n van,

	PIROSLED var PORTB.7
	ZOLDLED var PORTB.6
    
	' Konfigurljuk a PORTA-t. Teht hogy melyik kivezetseket akarjuk digitlis, vagy 
	' analg portnak hasznlni. 
	' Ezeket az ADCON1 regiszterbe tlttt adat fogja meghatrozni. 
	' Szval most a PORTA0-7 mind mint digitlis port legyen hasznlva.
	

		' Helyet foglalunk a vltozoknak a mikrokontroller RAM-jaban

	SZMPDELAY var Byte
	PROGRAM var Byte
	UZEMMOD var Byte	
   	PARAM var word
    STEPTIME var word   
    LEPES var word        
    LEPESPARAM var word 
    TIMEPARAM var word    
     
    BILLPERG var Byte 
    PERGETO var Byte     
    LEPTETOIMPPARAM var byte
    NYOMESZ var Byte 
    BEMFLAG var BIT
    EEPFLAG var BIT  
    PARAMBE var BIT    
   	MPBIT var BIT  
   	BILLFLAG var BIT 
  	START var BIT
  	IRANY var BIT
    FRISSLCD var BIT   
  	ORAJEL var BIT
  	
  	TIME var Byte  	
  	PERC var Byte
    MP var Byte
    SZMP var Byte
    ora var Byte
    tiktak var Byte     
    tizesoszto var byte
    BILLTIME var BIT
 			

nullaz: 
    PROGRAM = 1
    EEPROM  1,[00,100,00,200,00,200,00,100,00,100,00,100,00,100,00,100,00,100,00,100]
    EEPROM  21,[00,100,00,200,00,200,00,100,00,100,00,100,00,100,00,100,00,100,00,100]
    READ PROGRAM,LEPESPARAM.BYTE1
    READ PROGRAM+1,LEPESPARAM.BYTE0
    read PROGRAM+2,TIMEPARAM.byte1
    read PROGRAM+3,TIMEPARAM.byte0

	perc = 0  
	mp = 0
    tiktak = 0
    start = 0
    UZEMMOD = 1  
    PARAMBE = 0  
    pause 100
    
    LCDOUT $fe,1,  "****Step/Dir****"	' LCD trles, es irs az els sorba
    LCDOUT $fe,$C0,"****PICPLC1*****"	'es iras a masodik sorba   
    pause 1500
    FRISSLCD = 1
    
main: 

    SELECT CASE UZEMMOD        ' 
                
          CASE 1
           If PARAMBE = 0 THEN        
                read ((PROGRAM * 4) - 3),LEPESPARAM.byte1
                read ((PROGRAM * 4) - 2),LEPESPARAM.byte0
                read ((PROGRAM * 4) - 1),TIMEPARAM.byte1
                read (PROGRAM * 4),TIMEPARAM.byte0
                LEPES = LEPESPARAM
                PARAMBE = 1
           endif               
                EN = not START  ' Ha start=1, akkor az Enable bemenetet aktivizlja, azaz alacsony szintre kapcsolja                
           If FRISSLCD = 1 THEN          
               LCDOUT $fe,$80,dec2 PROGRAM ,". Program ","M: ",#UZEMMOD ' irs az els sorba
               LCDOUT $fe,$C0,"L: ",dec5 LEPESPARAM," T:",dec5 TIMEPARAM 
               FRISSLCD = 0  'Kirtuk amit kell, a jelz bitet most mr alaphelyzetbe lltjuk 
           endif
               
          CASE 2
           If FRISSLCD = 1 THEN          
               LCDOUT $fe,$80,"Lepes Szam ","Pr: ",#PROGRAM ' irs az els sorba
               LCDOUT $fe,$C0,"L: ",dec5 LEPESPARAM," T:",dec5 TIMEPARAM                     
               FRISSLCD = 0  'Kirtuk amit kell, a jelz bitet most mr alaphelyzetbe lltjuk
           endif
                                       
          CASE 3         
           If FRISSLCD = 1 THEN
               LCDOUT $fe,$80,"Lepes ido  ","Pr: ",#PROGRAM ' irs az els sorba
               LCDOUT $fe,$C0,"L: ",dec5 LEPESPARAM," T:",dec5 TIMEPARAM
               FRISSLCD = 0  'Kirtuk amit kell, a jelz bitet most mr alaphelyzetbe lltjuk
           endif           
           
          case 4
            IF EEPFLAG = 1 THEN        ' Volt paramter llts?  Ha igen eepromba ments.
               LCDOUT $fe,1            'LCD torles, es
               LCDOUT $fe,$C0,"Mentes"	'iras a masodik sorba  
               wRITE ((PROGRAM * 4) - 3),LEPESPARAM.byte1    ' 4 bjtot mentnk egyms utn. 
               wRITE ((PROGRAM * 4) - 2),LEPESPARAM.byte0    ' az EEPROM cm sorszma a programszm 
               WRITE ((PROGRAM * 4) - 1),TIMEPARAM.byte1     ' szorozva 4-el, minusz 3, 2, 1
               WRITE (PROGRAM * 4),TIMEPARAM.byte0
               EEPFLAG = 0       ' eeprom ments rendben, jelzflag nullzva

               PAUSE 1000                                   
            ENDIF                            

               UZEMMOD = 1      ' automatikusan visszalpnk az 1-es, alap zembe
               FRISSLCD = 1   
               PARAMBE = 0
    end select      

        NYOMESZ = 0
        IF K1GOMB = 0 THEN NYOMESZ = 1       ' Melyik gombot nyomtuk meg?
        IF K2GOMB = 0 THEN NYOMESZ = 2
        IF K3GOMB = 0 THEN NYOMESZ = 3
        IF K4GOMB = 0 THEN NYOMESZ = 4
        
        IF BEMENET = 0 THEN NYOMESZ = 1 'Ha a B4 bemenet alacsony, ugyanaz trtnik, mintha az 1-es gombot lenyomjuk
                
        IF NYOMESZ = 0 THEN GOTO nincsgomb    
        
        SELECT CASE NYOMESZ        ' PORTC xxyyyyxx
                
                CASE 1             
                    goto GOMB1 
                CASE 2
                    goto GOMB2  
                CASE 3
                    goto GOMB3  
                CASE 4
                    goto GOMB4   
        end select
 
GOMB1:                                ' indts/lellts gomb
   
        If BILLFLAG = 0 THEN
            START = 1             ' START6STOP jelz bit
            
            if START = 1 then     ' Ha START, akkor az aktulis lpsparamtert betlti a lpsszmllba 
            LEPES = LEPESPARAM + 1       
            endif
            
            FRISSLCD = 1          ' LCD kijelzs frissts
                
        endif
            BILLFLAG = 1          ' gomb "lekezelve", billenty jelzbit 1-be
        goto tovabb
        
' bellt men
        
                     
GOMB2:           'K2 a felfele gomb


        SELECT CASE UZEMMOD        ' 

                CASE 1
                    PROGRAM = PROGRAM + 1
                    IF PROGRAM = 11 then PROGRAM = 1
                    FRISSLCD = 1  
                    PARAMBE = 0   
                    pause 300
                CASE 2
                    PARAM = LEPESPARAM
                    gosub FELFELE
                    LEPESPARAM = PARAM      

                CASE 3
                    PARAM = TIMEPARAM
                    gosub FELFELE
                    TIMEPARAM = PARAM    

        end select
        goto tovabb         
  
         
GOMB3:      'K3 a lefele gomb

        SELECT CASE UZEMMOD       
                case 1 ' 
                    PROGRAM = PROGRAM - 1
                    IF PROGRAM = 0 then PROGRAM = 10
                    FRISSLCD = 1
                    PARAMBE = 0                    

                    pause 300                
                CASE 2
                    PARAM = LEPESPARAM
                    gosub LEFELE
                    LEPESPARAM = PARAM      

                CASE 3
                    PARAM = TIMEPARAM
                    gosub LEFELE
                    TIMEPARAM = PARAM    
   
        end select       
        goto tovabb   
 	 
GOMB4:            
 

	     If BILLFLAG = 0 THEN
            UZEMMOD = UZEMMOD + 1  
               if UZEMMOD > 4 then UZEMMOD = 1
            FRISSLCD = 1  

            pause 400
         endif
            BILLFLAG = 1
         goto tovabb    
  
nincsgomb:
        BILLFLAG = 0
        BILLPERG = 0 
        PERGETO = 1
tovabb:
        ZOLDLED = CLOCK  
       ' PIROSLED = DIR     
        PIROSLED = EN   
          
  	  goto main		' Ugras a ciklus elejere, kezdodik minden ujra... 
  	  
  	  

    FELFELE :         ' paramter rtk cskkents
           IF billtime = 1 THEN
                billtime = 0
                BILLPERG = BILLPERG + 1 
        
                IF BILLPERG = 250 THEN
                    BILLFLAG = 0
                    BILLPERG = 220 + PERGETO
                    PERGETO = PERGETO + 1
                    if PERGETO > 28 then PERGETO = 28
                ENDIF           
            endif
        
            If BILLFLAG = 0 THEN
                PARAM = PARAM + 1
                    if param >= 50001 then param = 1
                FRISSLCD = 1
                EEPFLAG = 1
            ENDIF
            BILLFLAG = 1            
     return       
     
    LEFELE :         ' paramter rtk cskkents
           IF billtime = 1 THEN
                billtime = 0
                BILLPERG = BILLPERG + 1 
        
                IF BILLPERG = 250 THEN
                    BILLFLAG = 0
                    BILLPERG = 220 + PERGETO
                    PERGETO = PERGETO + 1
                    if PERGETO > 28 then PERGETO = 28                    
                ENDIF           
            ENDIF   
         
            If BILLFLAG = 0 THEN
                PARAM = PARAM - 1
                    if param = 0 then param = 50000
                FRISSLCD = 1
                EEPFLAG = 1
            ENDIF
            BILLFLAG = 1
      return
      


        Disable		' Disable interrupts during interrupt handler
  	  
'Szval ha 4 megs a kvarc, akkor az fosc/4 ugye 1.000.000 Hz. Ezt osztjuk elbb 10-el, majd  1-el.
'Teht 100.000 Hz-es jel lpteti a TMR2 szmllt, s 10 lps utn lesz azonos az rtke a PR2-vel.
'Ekkor 1-be ugrik a PIR1.1 nev bit. Ezzel egy jabb 10-es osztst tudtunk csinlni.
'A 100.000/10=10000 Hz. Szval ez msodpercenknt 10000-szr fog megtrtnni. Vagy 0.1 millisecundumonknt, ahogy tetszik.     
'Szval mg egy 100-as oszts, s aztn mg egy 100-as, s meg van az htott 1 msodperces idalapunk. Na teht:
   
tickint:   
    INTCON.2 = 0    ' Reseteljk a timer0 "tlcsorduls" megszakts jelz bitet
    TMR0 = 100
   
      tiktak = tiktak + 1    ' Minden 0.01 mS utn - szzezred msodpercenknt - eggyel n   
      steptime = steptime + 1
      LEPTETOIMPPARAM = LEPTETOIMPPARAM + 1
      if LEPTETOIMPPARAM = 100 then ORAJEL = 0
      
        if STEPTIME >= TIMEPARAM then 
            STEPTIME = 0
            orajel = 1
            LEPTETOIMPPARAM = 0
            LEPES = LEPES - 1
            IF LEPES = 0 then START = 0           
        endif
        
        CLOCK = ORAJEL and START    
      If tiktak < 99 Then timerexit 'Ha mg nem rtk el a 100-at, kiugrunk
 	            ' 100 x 0.0001 = 0,01, azaz egy szzadmsodperc eltelt!
        tiktak = 0  ' kezdjk ellrl a szmolst	
        
'        tizesoszto = tizesoszto + 1  
'      If tizesoszto < 9 Then timerexit 'Ha mg nem rtk el a 10-et, kiugrunk     
'        tizesoszto = 0  ' kezdjk ellrl a szmolst        
        
        BILLTIME = 1			
        SZMP = SZMP + 1  ' Szmoljuk a szzadmsodperceket
      If SZMP < 100 Then timerexit 'Ha mg nem rtk el a 100-at, kiugrunk  
        SZMP = 0    ' ha megvolt a 100 szzadmsodperc, kezdjk nulltl jra a szmllst, 
        MP = MP + 1 ' s nveljk a msodpercek szmt       
        MPBIT = 1   ' van egy "eltelt egy msodperc" jelz bitnk, azt is bebillentjk
        TOGGLE PORTA.4 ' tkapcsoljuk a LED llapott.
                

    timerexit: 
'        INTCON.2 = 0    ' Reseteljk a timer0 "tlcsorduls" megszakts jelz bitet
        Resume

    'endif
    
    END				' Itt a progi vege. 	
